Bug 86039 - SIDEBAR: Styles gallery tab
Summary: SIDEBAR: Styles gallery tab
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.4.0.0.alpha1
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Sidebar-New-Decks
  Show dependency treegraph
 
Reported: 2014-11-08 17:56 UTC by Yousuf Philips (jay) (retired)
Modified: 2017-10-16 15:01 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
sample mockup (25.52 KB, image/png)
2014-11-08 19:43 UTC, Yousuf Philips (jay) (retired)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) (retired) 2014-11-08 17:56:47 UTC
Similar to the clipart gallery, it would be great if we included a style gallery so users could find useful styles to add to their documents, rather than having to always creating their own. Users will easily be able to apply these styles to the current document and also save a created style into the gallery.

Entries in the style gallery can either be single styles or group styles. Group styles would have a collection of styles for heading, text body, etc. to easily change the entire style of a document.
Comment 1 Yousuf Philips (jay) (retired) 2014-11-08 19:43:00 UTC
Created attachment 109138 [details]
sample mockup
Comment 2 A (Andy) 2014-11-08 20:50:01 UTC
Is my understanding correct, that this regarding the "Styles and Formatting" section in the sidebar?  Does it mean that you would get a kind of preview for the different styles and formats?  
I ask this, because I would like to have a "preview" of the styles and formatting maybe similar to the font preview.  Currently, we have there a long list where you don't know in advance how this would look like.  
And as I understand this mockup it would not only show a preview, but you would also have different kinds of formatting for instance for text body and others among you could choose?  This would be very good because the standard headings formats are not the one I would like to have and therefore it would be great if you could choose there between more different types of headings for instance for Heading 1 to 5 (the ones I use most).
Comment 3 Yousuf Philips (jay) (retired) 2014-11-08 21:47:20 UTC
Hi Andy,

(In reply to A (Andy) from comment #2)
> Is my understanding correct, that this regarding the "Styles and Formatting"
> section in the sidebar?  Does it mean that you would get a kind of preview
> for the different styles and formats?  

This is a new tab for the sidebar that has a gallery of styles that can be added to a document and it shows a preview of it.

> I ask this, because I would like to have a "preview" of the styles and
> formatting maybe similar to the font preview.  Currently, we have there a
> long list where you don't know in advance how this would look like.  

The styles and formatting tab list the styles available in your document and there isnt a preview of these styles.

> And as I understand this mockup it would not only show a preview, but you
> would also have different kinds of formatting for instance for text body and
> others among you could choose?  This would be very good because the standard
> headings formats are not the one I would like to have and therefore it would
> be great if you could choose there between more different types of headings
> for instance for Heading 1 to 5 (the ones I use most).

Yes it would list a variety of different types of a particular style so that you can apply that variant to your document.
Comment 4 A (Andy) 2014-11-08 21:59:00 UTC
Hi Jay,

(In reply to Jay Philips from comment #3)
...
> 
> > I ask this, because I would like to have a "preview" of the styles and
> > formatting maybe similar to the font preview.  Currently, we have there a
> > long list where you don't know in advance how this would look like.  
> 
> The styles and formatting tab list the styles available in your document and
> there isnt a preview of these styles.

Does it mean that also with your proposal the current styles and formatting section from LO 4.3 sidebar would still stay as it is without any preview?

...
Comment 5 Yousuf Philips (jay) (retired) 2014-11-09 02:18:33 UTC
Hi Andy,

(In reply to A (Andy) from comment #4)
> Does it mean that also with your proposal the current styles and formatting
> section from LO 4.3 sidebar would still stay as it is without any preview?

Yes styles and formatting is for style management, this new tab would be only to add new styles to the document.
Comment 6 A (Andy) 2014-11-09 09:55:13 UTC
(In reply to Jay Philips from comment #5)
> Hi Andy,
> 
> (In reply to A (Andy) from comment #4)
> > Does it mean that also with your proposal the current styles and formatting
> > section from LO 4.3 sidebar would still stay as it is without any preview?
> 
> Yes styles and formatting is for style management, this new tab would be
> only to add new styles to the document.

OK, but nevertheless this style gallery proposal with a preview sounds for me very good and I hope that in future there will be also a kind of preview for the current style management.
Comment 7 Tin Man 2014-11-15 20:35:30 UTC
If I understand the proposal correctly, this would be a way to quickly change the look of a single style based on some presets.

If I'm right, I don't see the utility in having something like this. Could you describe a realistic scenario in which one might use this?

If this is meant to be a way to quickly change a single style, nothing beats being able to change the hard formatting of a selection and then changing the style based on that selection. Given that one generally tweaks the style because they have a particular look in mind, I doubt presets would be helpful in this case.

If this is intended as a way to quickly change the appearance of text in a document in general, then themes take care of this in a much better way. It'd be better to direct development to implement themes (something that will need to be done anyway for MS Office compatibility).
Comment 8 Yousuf Philips (jay) (retired) 2014-11-16 01:34:57 UTC
(In reply to Mirek2 from comment #7)
> If I understand the proposal correctly, this would be a way to quickly
> change the look of a single style based on some presets.

Yes you'd be able to change a single or group of styles based on some presets.

> If I'm right, I don't see the utility in having something like this. Could
> you describe a realistic scenario in which one might use this?

Scenario for single style: User opens LO. He adds header text and sets it to Heading 1. He doesnt like how it looks. He opens up the style gallery and browses through the heading 1 list for something he likes. He applies it.

Scenario for group style: User opens a MS Word document in LO. He hates the currently applied style and wants to reset it to LO's default style. He opens up the style gallery and browses the group style list for the LO default style. He applies it.

> If this is meant to be a way to quickly change a single style, nothing beats
> being able to change the hard formatting of a selection and then changing
> the style based on that selection.

For advanced users, this would likely be their approach, or alternatively, they would create the new style in the style dialog box. But this tab is primarily targeting users with no knowledge of styles and users who know about styles but would less likely create their own.

> Given that one generally tweaks the style
> because they have a particular look in mind, I doubt presets would be
> helpful in this case.

Yes more advanced users will likely tweak their style in the style, while less style savvy users will likely apply direct over an applied style to tweak it.

> If this is intended as a way to quickly change the appearance of text in a
> document in general, then themes take care of this in a much better way.
> It'd be better to direct development to implement themes (something that
> will need to be done anyway for MS Office compatibility).

The group styles would work like a combination of MS Office's themes and style sets.

In order to push users to use styles, we need to first get them into using styles, and in order to get them into using styles, we need to give them a collect of style presets, which they can easily apply to their documents.
Comment 9 Yousuf Philips (jay) (retired) 2014-11-19 00:07:48 UTC
It seems that the styles gallery tab of predefined styles would be very useful in Calc when taking into consideration the comments that recently came in through our recent Calc survey. Here are a few:

1) ... A Dropdown list to "Apply Style" like the one in writer would encourage me to use styles. And there should be a nice set of predefined styles.

2) ... When looking at a spreadsheet, there's only a limited number of cell types and therefore a limited number of styles you require. These styles should be easy to use and be reliable. Ideally manual editing should be unnecessary. A useful set of default syles, targeted at spreadsheets rather than generic usage would be a GREAT (if not to say obligatory) start.

3) It would help a lot for the use of styles to see a preview in the list. I think this is the case also for other LibO apps. But there is a need of more default styles (only 5 currently). ...
Comment 10 Jan Holesovsky 2015-03-17 13:29:23 UTC
Some random code pointers:

The previews of the styles in the toolbar is done in svx/source/tbxctrls/tbcontrl.cxx, see SvxStyleBox_Impl::UserDraw().

The sidebar with styles is I think here: sfx2/source/dialog/templdlg.cxx
Comment 11 Jan Holesovsky 2015-03-17 13:31:56 UTC
Some random code pointers:

The previews of the styles in the toolbar is done in svx/source/tbxctrls/tbcontrl.cxx, see SvxStyleBox_Impl::UserDraw().

The sidebar with styles is I here: sfx2/source/dialog/templdlg.cxx .  The SfxTemplatePanelControl is plugged into the sidebar in svx/source/sidebar/PanelFactory.cxx (seach for new SfxTemplatePanelControl).

For anything new in the sidebar, it would be better to use the .ui descriptions; so if you want to build on top of the existing styles panel, best to convert it to .ui as the first thing.
Comment 12 Tomaz Vajngerl 2015-04-14 00:58:35 UTC
Jay, do you think this still makes sense when we would have style sets (Quick styles)? I guess a normal user just wants to pick one consistent look he likes and maybe manually tweak some thing here and there. With themes he can in addition change the fonts and colors which should already make him happy.

I think we should rather think about how to make it simpler to change a style and bring styles closer to the user. Currently our sidebar is very direct formatting oriented as the styles are totally separate, but we could tweak that. For example I like how iWork Pages (13) shows the current style on the top and the user can has an easy access to other styles from there. Also the user can see quickly if any direct formatting was applied and has the option to update the style.
Comment 13 Yousuf Philips (jay) (retired) 2015-04-23 02:46:51 UTC
(In reply to Tomaz Vajngerl from comment #12)
> Jay, do you think this still makes sense when we would have style sets
> (Quick styles)? I guess a normal user just wants to pick one consistent look
> he likes and maybe manually tweak some thing here and there. With themes he
> can in addition change the fonts and colors which should already make him
> happy.

Well this implementation had styles sets which i referred to as group styles in the description, but also allowed the user to play with a variety of different styles for different parts of the document and then likely they would tweak it to match with similar colors if thats what they wanted. With styles sets, you cant mix and match different parts of one style set with another, which is possible with this implementation.

> I think we should rather think about how to make it simpler to change a
> style and bring styles closer to the user. Currently our sidebar is very
> direct formatting oriented as the styles are totally separate, but we could
> tweak that. For example I like how iWork Pages (13) shows the current style
> on the top and the user can has an easy access to other styles from there.
> Also the user can see quickly if any direct formatting was applied and has
> the option to update the style.

Yes the most important feature missing from the sidebar in writer's properties tab is style selection (bug 73071). If its possible to implement iWork Pages' mechanism of showing that a paragraph style has been modified by direct formatting and provide an easily means of updating it, i think it would be a good feature to have in the sidebar. In my first mockup of the sidebar properties tab (bug 83830), i had an update button next to the drop down.

https://redmine.documentfoundation.org/attachments/download/196/Proposal---Explained.png